ODS GRAPHICS OFF;
ODS HTML CLOSE;
ODS LISTING;

DATA wisc1;
    INFILE 'C:\Users\kjgrimm\Documents\UCD Folder\UCD Folder\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session D - Lecture - Two-Occasion Models\Session D - Computer Scripts\wisc3raw.dat';
    INPUT id verb1 verb2 verb4 verb6 perfo1	perfo2 perfo4 perfo6
             info1 comp1 simi1 voca1 info6 comp6 simi6 voca6 
             momed grad constant;
RUN;

* Basic Descriptives;
PROC CORR DATA = wisc1;
	VAR perfo1 perfo2;
RUN;

GOPTIONS
	FTEXT = 'Albany AMT'
	HTEXT = 1.5
	CTEXT = black;

ODS GRAPHICS ON;
ODS HTML FILE = "Plot1.html" style=journal gpath="C:\Users\kjgrimm\Documents\UCD Folder\UCD Folder\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session D - Lecture - Two-Occasion Models\Session D - Computer Scripts";
PROC GPLOT DATA = wisc1;
	SYMBOL1
		V = dot
		H = 1
		C = black
		R = 500;
	AXIS1
		LABEL = (A=90 F='Albany AMT' H = 2 'WISC Performance - Grade 2')
		ORDER = (0 to 60 BY 10)
		MINOR = none
		OFFSET= (5 pct, 5 pct);
	AXIS2
		LABEL = (F='Albany AMT' H = 2 'WISC Performance - Grade 1')
		ORDER = (0 to 60 BY 10)
		MINOR = none
		OFFSET= (5 pct, 5 pct);
	PLOT perfo2 * perfo1 / NOLEGEND VAXIS=AXIS1 HAXIS=AXIS2;
RUN;
ODS GRAPHICS OFF;
ODS HTML CLOSE;

DATA wisc_long;
	SET wisc1;
	perf = perfo1; grade = 1; OUTPUT;
	perf = perfo2; grade = 2; OUTPUT;

	KEEP id perf grade;
RUN;

ODS GRAPHICS ON;
ODS HTML FILE = "Plot1.html" style=journal gpath="C:\Users\kjgrimm\Documents\UCD Folder\UCD Folder\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session D - Lecture - Two-Occasion Models\Session D - Computer Scripts";
PROC GPLOT DATA = wisc_long;
	SYMBOL1
		V = dot
		H = 1
		C = black
		R = 500
		W = 1
		I = join;
	AXIS1
		LABEL = (A=90 F='Albany AMT' H = 2 'WISC Performance')
		ORDER = (0 to 60 BY 10)
		MINOR = none
		OFFSET= (5 pct, 5 pct);
	AXIS2
		LABEL = (F='Albany AMT' H = 2 'Grade')
		ORDER = (1 to 2 BY 1)
		MINOR = none
		OFFSET= (5 pct, 5 pct);

	PLOT perf * grade = id / NOLEGEND VAXIS=AXIS1 HAXIS=AXIS2;
RUN;
ODS GRAPHICS OFF;
ODS HTML CLOSE;

*Type A with Group - Traditional Autoregressive Model for Repeated Measures;
DATA wisc2;
	SET wisc1;
	perf_by_grad = perfo1 * grad;
RUN;
PROC REG DATA = wisc2;
	ModA1: MODEL perfo2 = perfo1 / STB;
	ModA2: MODEL perfo2 = perfo1 grad / STB;
	ModA3: MODEL perfo2 = perfo1 grad perf_by_grad / STB;
RUN;

ODS GRAPHICS ON;
ODS HTML FILE = "Plot1.html" style=journal gpath="C:\Users\kjgrimm\Documents\UCD Folder\UCD Folder\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session D - Lecture - Two-Occasion Models\Session D - Computer Scripts";
PROC GPLOT DATA = wisc1;
	SYMBOL1
		I = RLCLM95
		V = dot
		H = 1
		C = black
		R = 500;
	AXIS1
		LABEL = (A=90 F='Albany AMT' H = 2 'WISC Performance - Grade 2')
		ORDER = (0 to 60 BY 10)
		MINOR = none
		OFFSET= (5 pct, 5 pct);
	AXIS2
		LABEL = (F='Albany AMT' H = 2 'WISC Performance - Grade 1')
		ORDER = (0 to 60 BY 10)
		MINOR = none
		OFFSET= (5 pct, 5 pct);
	PLOT perfo2 * perfo1 / NOLEGEND VAXIS=AXIS1 HAXIS=AXIS2;
RUN;
ODS GRAPHICS OFF;
ODS HTML CLOSE;

* Descriptive Information by Group;
PROC FREQ DATA = wisc1;
	TABLES grad;
RUN;

PROC CORR DATA = wisc1;
	VAR perfo1 perfo2;
RUN;
PROC SORT DATA = wisc1;
	BY grad;
PROC CORR DATA = wisc1;
	VAR perfo1 perfo2;
	BY grad;
RUN;


*Model A2: Implied Mean Structure;
DATA sim;
	b0 = 11.11695;
	b1 = 0.89173;
	b2 = 2.40481;
	DO x = 0 to 60;
		DO g = 0 to 1;
		y = b0 + b1 * x + b2 * g;
		OUTPUT;
		END;
	END;
RUN;
ODS GRAPHICS ON;
ODS HTML FILE = "Plot1.html" style=journal gpath="C:\Users\kjgrimm\Documents\UCD Folder\UCD Folder\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session D - Lecture - Two-Occasion Models\Session D - Computer Scripts";

PROC GPLOT DATA = sim;
	SYMBOL1
		I = join
		V = none
		W = 3
		C = black
		R = 1
		L = 1;
	SYMBOL2
		I = join
		V = none
		W = 3
		C = red
		R = 1
		L = 1;
	AXIS1
		LABEL = (A=90 F='Albany AMT' H = 2 'WISC Performance - Grade 2')
		ORDER = (0 to 60 BY 10)
		MINOR = none
		OFFSET= (5 pct, 5 pct);
	AXIS2
		LABEL = (F='Albany AMT' H = 2 'WISC Performance - Grade 1')
		ORDER = (0 to 60 BY 10)
		MINOR = none
		OFFSET= (5 pct, 5 pct);
	PLOT y * x = g/ NOLEGEND VAXIS=AXIS1 HAXIS=AXIS2;
RUN;
ODS GRAPHICS OFF;
ODS HTML CLOSE;

*Type D - Difference Score Model for Two Occasion;
DATA wisc2;
	SET wisc1;
	delta = perfo2 - perfo1;
RUN;
PROC REG DATA = wisc2;
	ModD0a: MODEL delta = / STB;
	ModD1a: MODEL delta = perfo1 / STB;
	ModD1b: MODEL delta = grad / STB;
	ModD2:  MODEL delta = perfo1 grad / STB;
	ModD3:  MODEL delta = perfo1 grad perf_by_grad / STB;
RUN;

*Prediction Equations;
*Model D2: Implied Mean Structure;
DATA sim;
	b0 = 11.12;
	b1 = -.11;
	b2 = 2.40;
	DO x = 0 to 60;
		DO g = 0 to 1;
		dy = b0 + b1 * x + b2 * g;
		OUTPUT;
		END;
	END;
RUN;

ODS GRAPHICS ON;
ODS HTML FILE = "Plot1.html" style=journal gpath="C:\Users\kjgrimm\Documents\UCD Folder\UCD Folder\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session D - Lecture - Two-Occasion Models\Session D - Computer Scripts";

PROC GPLOT DATA = sim;
	SYMBOL1
		I = join
		V = none
		W = 3
		C = black
		R = 1
		L = 1;
	SYMBOL2
		I = join
		V = none
		W = 3
		C = red
		R = 1
		L = 1;
	AXIS1
		ORDER = (0 to 15 BY 5)
		LABEL = (A = 90 H = 2 F = 'Albany AMT' 'Change in WISC Performance')
		MINOR = none;
	AXIS2
		ORDER = (0 to 60 BY 10)
		LABEL = (F = 'Albany AMT' H = 2 'WISC Performance - Grade 1')
		MINOR = none;
	PLOT dy * x = g/NOLEGEND VAXIS =AXIS1 HAXIS = AXIS2;
RUN;

ODS GRAPHICS OFF;
ODS HTML CLOSE;

