﻿
GET DATA  /TYPE=TXT
  /FILE= 'D:\Workshops\APA_2015\Section C_SEM\wisc3raw.dat'
  /ENCODING='Locale'
  /FIXCASE=1
  /ARRANGEMENT=FIXED
  /FIRSTCASE=1
  /IMPORTCASE=ALL
  /VARIABLES=
  /1 id 0-9 F10.3
  verb1 10-19 F10.3
  verb2 20-29 F10.3
  verb4 30-39 F10.3
  verb6 40-49 F10.3
  perfo1 50-59 F10.3
  perfo2 60-69 F10.3
  perfo4 70-79 F10.3
  perfo6 80-89 F10.3
  info1 90-99 F10.3
  comp1 100-109 F10.3
  simi1 110-119 F10.3
  voca1 120-129 F10.3
  info6 130-139 F10.3
  comp6 140-149 F10.3
  simi6 150-159 F10.3
  voca6 160-169 F10.3
  momed 170-179 F10.3
  grad 180-189 F10.3
  constant 190-199 F10.3.
CACHE.
EXECUTE.
DATASET NAME DataSet2 WINDOW=FRONT.

*Restructure data from wide to long.
VARSTOCASES
  /MAKE verb FROM verb1 verb2 verb4 verb6
  /MAKE perfo FROM perfo1 perfo2 perfo4 perfo6
  /INDEX=occasion(4) 
  /KEEP=id momed grad constant
  /NULL=KEEP.

if (occasion=1) grade = 1.
if (occasion=2) grade = 2.
if (occasion=3) grade = 4.
if (occasion=4) grade = 6.
EXECUTE.

*/* ex1: intercept-only model */

mixed perfo with grade
 /print = solution testcov
 /fixed = intercept 
 /random = intercept | subject(id) covtype(id).

/* ex2: linear growth model */

mixed perfo with grade
 /print = solution testcov
 /fixed = intercept grade
 /random = intercept grade | subject(id) covtype(un).


/* ex3: quadratic growth model */

mixed perfo with grade
 /print = solution testcov
 /fixed = intercept grade grade*grade
 /random = intercept grade | subject(id) covtype(un).
