# load packages

library(nlme)


# Load the data
wisc<-read.table("D:/Workshops/APA_2015/Section C_SEM/wisc3raw.dat")

names(wisc) = c('id','verb1','verb2','verb4','verb6','perfo1','perfo2','perfo4','perfo6',
    	'info1','comp1','simu1','voca1','info6','comp6','simu6','voca6','momed','grad','constant')

head(wisc)

wisc_long = reshape(wisc, idvar='id', varying=c('verb1','perfo1','verb2','perfo2','verb4','perfo4','verb6','perfo6'),
                    times = c(1,2,4,6),
                    v.names = c('x','y'), direction='long')

wisc_long = wisc_long[order(wisc_long$id, wisc_long$time), ]
wisc_long$verb = wisc_long$x
wisc_long$perfo = wisc_long$y

grade = time

# ex1: intercept-only growth model

icept <- lme(fixed = perfo ~ 1 , random = ~ 1 |id, data = wisc_long)
summary(icept)

# ex2: linear growth model

linear <- lme(fixed = perfo ~ time, random = ~ time|id, data = wisc_long)
summary(linear)

# ex2: linear growth model

linear <- lme(fixed = perfo ~ grade, random = ~ grade|id, data = wisc_long)
summary(linear)

# ex3: quadratic growth model

quad <- lme(fixed = perfo ~ grade + grade2, random = ~ grade|id, data = wisclong)
summary(quad)
