################################################################################
# Title: V subtests: 2 Factor model Verbal information (Vc) Verbal reasoning (Vr)
# File: Session L - Computer Programs/prog02_vc_2fac.R
# Source File: Session L - Computer Programs/prog02_vc_2fac.out
# Created: Tue Jun 21 00:15:18 2011
################################################################################
# TranslateOpenMx library (Version 0.1)
################################################################################

# load OpenMx
library(OpenMx)

# load data
rto8age2 <- read.table('rto8age2.dat', na.string="c('USEVAR' , '='      , 'info_06', 'voca_06', 'comp_06', 'simi_06')")
names(rto8age2) <- c('id', 'moeducat', 'age_06', 'info_06', 'comp_06',
    'simi_06', 'voca_06', 'picc_06', 'pica_06', 'bloc_06',
    'obje_06', 'age_11', 'info_11', 'comp_11', 'simi_11',
    'voca_11', 'picc_11', 'pica_11', 'bloc_11', 'obje_11')

# specify model
VModel <- mxModel("V subtests_ 2 Factor model Verbal information _Vc_ Verbal reasoning _Vr_",
    type="RAM",
    # specify data and variables
    mxData(rto8age2, "raw"),
    manifestVars=c('info_06', 'voca_06', 'comp_06', 'simi_06'),
    latentVars=c('vc_06', 'vr_06'),
    # specify 'BY' parameter(s)
    mxPath(from='vc_06', to=c('info_06', 'voca_06'), arrows=1,
        free=TRUE, values=c(4.553, 4.675), labels=c('p1', 'p2')),
    # specify 'BY' parameter(s)
    mxPath(from='vr_06', to=c('comp_06', 'simi_06'), arrows=1,
        free=TRUE, values=c(6.882, 4.779), labels=c('p3', 'p4')),
    # specify 'WITH' parameter(s)
    mxPath(from='vc_06', to='vr_06', arrows=2,
        free=TRUE, values=1.035, labels='p5'),
    # specify 'Mean' parameter(s)
    mxPath(from='one', to=c('vc_06', 'vr_06'), arrows=1,
        free=FALSE, values=0, labels=NA),
    # specify 'Intercept' parameter(s)
    mxPath(from='one', to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=1,
        free=TRUE, values=c(19.776, 20.396, 21.797, 14.903), labels=c('p6', 'p7', 'p8', 'p9')),
    # specify 'Variance' parameter(s)
    mxPath(from=c('vc_06', 'vr_06'), to=c('vc_06', 'vr_06'), arrows=2,
        free=FALSE, values=1, labels=NA),
    # specify 'Variance' parameter(s)
    mxPath(from=c('info_06', 'voca_06', 'comp_06', 'simi_06'), to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=2,
        free=TRUE, values=c(16.528, 17.538, 47.076, 34.045), labels=c('p10', 'p11', 'p12', 'p13')))

# run model
VModelResults <- mxRun(VModel)

# view summary of results
summary(VModelResults)
