*****************************************************
*		ATI workshop					            *
*		Session L    :                              *
*       rto8age2.dta                             	* 
*       Mplus file:    prog12_GcGf_2fac           	*
*****************************************************

*TITLE:    Gc-Gf: 2 Factor model
clear

* Read data - rto8age2.dat
cd "C:\Users\JiHoon\Documents\UVa_Tenure\Service\Advising\ATI_STATA_RyooShi\Week3_22Apr14\Session L - Lecture - Common Factors\Session_L_Programs\Stata" 
use "rto8age2.dta"

* Model
sem (Gc_06 -> comp_06, ) (Gc_06@L2 -> voca_06, ) (Gf_06 -> bloc_06, ) (Gf_06@L4 -> obje_06, ), ///
covstruct(_lexogenous, diagonal) iterate(10000) latent(Gc_06 Gf_06 ) ///
cov( Gc_06@1 Gc_06*Gf_06 Gf_06@1) means( Gc_06@0 Gf_06@0) nocapslatent

* Standardized
sem (Gc_06 -> comp_06, ) (Gc_06@L2 -> voca_06, ) (Gf_06 -> bloc_06, ) (Gf_06@L4 -> obje_06, ), ///
covstruct(_lexogenous, diagonal) iterate(10000) latent(Gc_06 Gf_06 ) ///
cov( Gc_06@1 Gc_06*Gf_06 Gf_06@1) means( Gc_06@0 Gf_06@0) standardized nocapslatent

* Goodness of fit
estat gof, stats(all)

// Not sure about how to add the TECH1 output (Mplus) from the postesitmation commands
// Others are correct.
