brad_fluid_4156a<-read.table("brad_fluid_4156a.dat",header=F)
names(brad_fluid_4156a)<-c("ind_41","cod_41","freas_41","pap_41","reas_41",
  	"ind_56","cod_56","freas_56","pap_56","reas_56")

cat_var<-c("ind_41","cod_41","freas_41","pap_41","reas_41",
  	"ind_56","cod_56","freas_56","pap_56","reas_56")

###################
#Constraints
#M1 - Factorial Invariance 
####################



m4.two_occ_irt_model<-'

#constrained Loadings Time 1

  gf_41=~ 1*L1*ind_41 +
	  L2*cod_41 +
          L3*freas_41 +
          L4*pap_41 +
	  L5*reas_41

  #Thresholds Time 1
  ind_41|t1 
  cod_41|t1 
  freas_41|t1
  pap_41|t1
  reas_41|t1

#Constrained Loadings Time 2
  gf_56=~ 1*L1*ind_56 +
	  L2*cod_56 +
          L3*freas_56 +
          L4*pap_56 +
	  L5*reas_56

  #Thresholds Time 2
  ind_56|t1 
  cod_56|t1 
  freas_56|t1
  pap_56|t1
  reas_56|t1

#Factor Variance and Covariance

gf_41~~start(.45)*gf_41
gf_56~~start(.4)*gf_56
gf_41~~start(.39)*gf_56

#Correlated Uniqueness
ind_41~~ind_56
cod_41~~cod_56
freas_41~~freas_56
pap_41~~pap_56
reas_41~~reas_56

'

m4_fit<-cfa(m4.two_occ_irt_model,data=brad_fluid_4156a,ordered=cat_var,link="probit",
estimator="dwls",verbose=T)

summary(m4_fit)
