#### TWO OCCASION  ######

wisc3raw<-read.table("wisc3raw.dat",header=F)
names(wisc3raw)<-c("id","verb1","verb2","verb4","verb6",
			      "perfo1","perfo2","perfo4","perfo6",
                         "info1","comp1","simi1","voca1","info6","comp6",
				"simi6","voca6","momed","grad","constant")

#recode for categorical analysis 

wisc3raw$perf_c2<-ifelse(wisc3raw$perfo2>35,1,0)
wisc3raw$perf_c4<-ifelse(wisc3raw$perfo4>35,1,0)


wisc_type_d_probit<-'

#Relationships
perf_c2~0*perf_c4
perf_c4~1*perf_c2

#Difference Score
delta=~1*perf_c4

#Thresholds
perf_c2|tau*t1
perf_c4|tau*t1

#Mean and Variance of Difference Score
delta~start(1.268)*1
delta~~0*delta
'


wisc_type_d_probit_fit<-lavaan(wisc_type_d_probit,
data=wisc3raw,ordered=c("perf_c4","perf_c2"),estimator="wlsmv")
summary(wisc_type_d_probit_fit)

