library(lavaan)

wisc3raw <- read.table("C:/Users/kjgrimm/Documents/UCD/Organization/Workshops/ATI/APA-ATI LSEM 2016/Session H - Lab - Growth/Session H - Programming Scripts/wisc3raw.dat")

names(wisc3raw) = c('id', 'verb1', 'verb2', 'verb4', 'verb6', 'perfo1', 'perfo2', 'perfo4', 'perfo6',
'info1', 'comp1', 'simi1', 'voca1', 'info6', 'comp6', 'simi6', 'voca6', 'momed', 'grad', 'constant')

MG.model <- '  b_0n =~ 1*perfo1 + 1*perfo2 + 1*perfo4 + 1*perfo6
           b_1n =~ 0*perfo1 + start(1)*perfo2 + start(3)*perfo4 + 5*perfo6 

perfo1~~u*perfo1
perfo2~~u*perfo2
perfo4~~u*perfo4
perfo6~~u*perfo6'
fit <- growth(MG.model, 
           data = wisc3raw, 
           group = "grad",
           group.equal = c("intercepts", "residuals", "lv.variances", "lv.covariances", "loadings"),
           mimic="mplus")
           
summary(fit, fit.measures=TRUE, standardized=TRUE)