install.packages('lavaan')


#reading in and formatting the data

x = read.table('C:/Users/kjgrimm/Documents/UCD/Organization/Workshops/ATI/APA-ATI LSEM 2015/Session S - Lecture - Nonlinearity/Session S - Programming Scripts/ecls_math_read_miss.dat', na.strings=".")
names(x) = c("id","female", "math_fk","math_sk","math_f1","math_s1","math_s3","math_s5","math_s8",
             "read_fk","read_sk","read_f1","read_s1","read_s3","read_s5","read_s8")
y = x[,3:9]

#lavaan
library(lavaan)

model = "
  #Factor structure
  x_0n =~ L01*math_fk + L02*math_sk + L03*math_f1 + L04*math_s1 + L05*math_s3 + L06*math_s5 + L07*math_s8
  x_1n =~ L11*math_fk + L12*math_sk + L13*math_f1 + L14*math_s1 + L15*math_s3 + L16*math_s5 + L17*math_s8
  x_2n =~ L21*math_fk + L22*math_sk + L23*math_f1 + L24*math_s1 + L25*math_s3 + L26*math_s5 + L27*math_s8
  x_3n =~ L31*math_fk + L32*math_sk + L33*math_f1 + L34*math_s1 + L35*math_s3 + L36*math_s5 + L37*math_s8

  #Means
  math_fk + math_sk + math_f1 + math_s1 + math_s3 + math_s5 + math_s8 ~ 0*1
  x_0n ~ start(-4)*1
  x_1n ~ beta_1*1
  x_2n ~ 0*1
  x_3n ~ 0*1

  #Variances
  math_fk ~~ sigma2_u*math_fk
  math_sk ~~ sigma2_u*math_sk
  math_f1 ~~ sigma2_u*math_f1
  math_s1 ~~ sigma2_u*math_s1
  math_s3 ~~ sigma2_u*math_s3
  math_s5 ~~ sigma2_u*math_s5
  math_s8 ~~ sigma2_u*math_s8

  x_0n ~~ 0*x_0n
  x_1n ~~ start(600)*x_1n
  x_2n ~~ start(0.002)*x_2n
  x_3n ~~ start(0.059)*x_3n
  
  #Covariances
  x_0n ~~ 0*x_1n + 0*x_2n + 0*x_3n
  x_1n ~~ start(0)*x_2n + start(0)*x_3n
  x_2n ~~ start(0)*x_3n

  #Phantom variables
  pbeta_2 =~ 0*math_fk
  pbeta_3 =~ 0*math_fk

  pbeta_2 ~~ 0*pbeta_2
  pbeta_3 ~~ 0*pbeta_3

  pbeta_2 ~ beta_2*1
  pbeta_3 ~ beta_3*1

  #Constraints
  L01 == 1
  L02 == 1
  L03 == 1
  L04 == 1
  L05 == 1
  L06 == 1
  L07 == 1

  L11 == exp(-1 * exp(-beta_2 * (0.0 - beta_3)))
  L12 == exp(-1 * exp(-beta_2 * (0.5 - beta_3)))
  L13 == exp(-1 * exp(-beta_2 * (1.0 - beta_3)))
  L14 == exp(-1 * exp(-beta_2 * (1.5 - beta_3)))
  L15 == exp(-1 * exp(-beta_2 * (3.5 - beta_3)))
  L16 == exp(-1 * exp(-beta_2 * (5.5 - beta_3)))
  L17 == exp(-1 * exp(-beta_2 * (8.5 - beta_3)))

  L21 == (beta_1 * 0.0 * exp(beta_2 * beta_3) - beta_1 * beta_3 * exp(beta_2 * beta_3))*
    (exp(-exp(-beta_2 * 0.0)*(beta_2*0.0*exp(beta_2 * 0.0)+exp(beta_2 * beta_3))))
  L22 == (beta_1 * 0.5 * exp(beta_2 * beta_3) - beta_1 * beta_3 * exp(beta_2 * beta_3))*
    (exp(-exp(-beta_2 * 0.5)*(beta_2*0.5*exp(beta_2 * 0.5)+exp(beta_2 * beta_3))))
  L23 == (beta_1 * 1.0 * exp(beta_2 * beta_3) - beta_1 * beta_3 * exp(beta_2 * beta_3))*
    (exp(-exp(-beta_2 * 1.0)*(beta_2*1.0*exp(beta_2 * 1.0)+exp(beta_2 * beta_3))))
  L24 == (beta_1 * 1.5 * exp(beta_2 * beta_3) - beta_1 * beta_3 * exp(beta_2 * beta_3))*
    (exp(-exp(-beta_2 * 1.5)*(beta_2*1.5*exp(beta_2 * 1.5)+exp(beta_2 * beta_3))))
  L25 == (beta_1 * 3.5 * exp(beta_2 * beta_3) - beta_1 * beta_3 * exp(beta_2 * beta_3))*
    (exp(-exp(-beta_2 * 3.5)*(beta_2*3.5*exp(beta_2 * 3.5)+exp(beta_2 * beta_3))))
  L26 == (beta_1 * 5.5 * exp(beta_2 * beta_3) - beta_1 * beta_3 * exp(beta_2 * beta_3))*
    (exp(-exp(-beta_2 * 5.5)*(beta_2*5.5*exp(beta_2 * 5.5)+exp(beta_2 * beta_3))))
  L27 == (beta_1 * 8.5 * exp(beta_2 * beta_3) - beta_1 * beta_3 * exp(beta_2 * beta_3))*
    (exp(-exp(-beta_2 * 8.5)*(beta_2*8.5*exp(beta_2 * 8.5)+exp(beta_2 * beta_3))))

  L31 == -beta_1 * beta_2 * exp(-exp(-beta_2*0.0)*((beta_2*0.0-beta_2*beta_3)*
    exp(beta_2 * 0.0)+exp(beta_2*beta_3)))
  L32 == -beta_1 * beta_2 * exp(-exp(-beta_2*0.5)*((beta_2*0.5-beta_2*beta_3)*
    exp(beta_2 * 0.5)+exp(beta_2*beta_3)))
  L33 == -beta_1 * beta_2 * exp(-exp(-beta_2*1.0)*((beta_2*1.0-beta_2*beta_3)*
    exp(beta_2 * 1.0)+exp(beta_2*beta_3)))
  L34 == -beta_1 * beta_2 * exp(-exp(-beta_2*1.5)*((beta_2*1.5-beta_2*beta_3)*
    exp(beta_2 * 1.5)+exp(beta_2*beta_3)))
  L35 == -beta_1 * beta_2 * exp(-exp(-beta_2*3.5)*((beta_2*3.5-beta_2*beta_3)*
    exp(beta_2 * 3.5)+exp(beta_2*beta_3)))
  L36 == -beta_1 * beta_2 * exp(-exp(-beta_2*5.5)*((beta_2*5.5-beta_2*beta_3)*
    exp(beta_2 * 5.5)+exp(beta_2*beta_3)))
  L37 == -beta_1 * beta_2 * exp(-exp(-beta_2*8.5)*((beta_2*8.5-beta_2*beta_3)*
    exp(beta_2 * 8.5)+exp(beta_2*beta_3)))
"

fit.lavaan = lavaan(model, data=y, missing="fiml")
summary(fit.lavaan, fit.measures=T)



#lavaan (0.5-16) converged normally after 2500 iterations
#
#                                                  Used       Total
#  Number of observations                         21045       21409
#
#  Number of missing patterns                       113
#
#  Estimator                                         ML
#  Minimum Function Test Statistic            14749.861
#  Degrees of freedom                                24
#  P-value (Chi-square)                           0.000
#
#Model test baseline model:
#
#  Minimum Function Test Statistic            88334.735
#  Degrees of freedom                                21
#  P-value                                        0.000
#
#User model versus baseline model:
#
#  Comparative Fit Index (CFI)                    0.833
#  Tucker-Lewis Index (TLI)                       0.854
#
#Loglikelihood and Information Criteria:
#
#  Loglikelihood user model (H0)             -361193.278
#  Loglikelihood unrestricted model (H1)     -353818.348
#
#  Number of free parameters                         11
#  Akaike (AIC)                              722408.556
#  Bayesian (BIC)                            722496.055
#  Sample-size adjusted Bayesian (BIC)       722461.098
#
#Root Mean Square Error of Approximation:
#
#  RMSEA                                          0.171
#  90 Percent Confidence Interval          0.168  0.173
#  P-value RMSEA <= 0.05                          0.000
#
#Standardized Root Mean Square Residual:
#
#  SRMR                                           0.096
#
#Parameter estimates:
#
#  Information                                 Observed
#  Standard Errors                             Standard
#
#                   Estimate  Std.err  Z-value  P(>|z|)
#Latent variables:
#  x_0n =~
#    math_fk (L01)     1.000       NA
#    math_sk (L02)     1.000       NA
#    math_f1 (L03)     1.000       NA
#    math_s1 (L04)     1.000       NA
#    math_s3 (L05)     1.000       NA
#    math_s5 (L06)     1.000       NA
#    math_s8 (L07)     1.000       NA
#  x_1n =~
#    math_fk (L11)     0.214    0.000 1284.808    0.000
#    math_sk (L12)     0.283    0.000 2070.982    0.000
#    math_f1 (L13)     0.356    0.000 4411.922    0.000
#    math_s1 (L14)     0.430    0.000 5163.428    0.000
#    math_s3 (L15)     0.684    0.000 3382.348    0.000
#    math_s5 (L16)     0.843    0.000 4046.387    0.000
#    math_s8 (L17)     0.950    0.000 8340.680    0.000
#  x_2n =~
#    math_fk (L21)   -54.961    0.059 -930.760    0.000
#    math_sk (L22)   -31.943    0.051 -629.331    0.000
#    math_f1 (L23)    -4.514    0.027 -164.525    0.000
#    math_s1 (L24)    23.537    0.010 2386.855    0.000
#    math_s3 (L25)    96.923    0.040 2422.705    0.000
#    math_s5 (L26)    97.953    0.028 3560.271    0.000
#    math_s8 (L27)    55.724    0.081  686.904    0.000
#  x_3n =~
#    math_fk (L31)   -20.384    0.033 -612.284    0.000
#    math_sk (L32)   -22.067    0.040 -545.718    0.000
#    math_f1 (L33)   -22.707    0.044 -520.550    0.000
#    math_s1 (L34)   -22.417    0.043 -519.077    0.000
#    math_s3 (L35)   -16.033    0.024 -678.745    0.000
#    math_s5 (L36)    -8.872    0.006 -1397.401    0.000
#    math_s8 (L37)    -3.007    0.001 -2026.350    0.000
#  pbeta_2 =~
#    math_fk           0.000
#  pbeta_3 =~
#    math_fk           0.000
#
#Covariances:
#  x_0n ~~
#    x_1n              0.000
#    x_2n              0.000
#    x_3n              0.000
#  x_1n ~~
#    x_2n              0.498    0.027   18.658    0.000
#    x_3n             -0.429    0.120   -3.573    0.000
#  x_2n ~~
#    x_3n             -0.037    0.001  -45.701    0.000
#
#Intercepts:
#    mth_fk            0.000
#    mth_sk            0.000
#    mth_f1            0.000
#    mth_s1            0.000
#    mth_s3            0.000
#    mth_s5            0.000
#    mth_s8            0.000
#    x_0n             -7.442    0.061 -121.665    0.000
#    x_1n   (bt_1)   154.241    0.157  983.101    0.000
#    x_2n              0.000
#    x_3n              0.000
#    pbet_2 (bt_2)     0.400    0.000 1098.720    0.000
#    pbet_3 (bt_3)     1.080    0.000 2636.067    0.000
#
#Variances:
#    mth_fk (sg2_)    49.984    0.323
#    mth_sk (sg2_)    49.984    0.323
#    mth_f1 (sg2_)    49.984    0.323
#    mth_s1 (sg2_)    49.984    0.323
#    mth_s3 (sg2_)    49.984    0.323
#    mth_s5 (sg2_)    49.984    0.323
#    mth_s8 (sg2_)    49.984    0.323
#    x_0n              0.000
#    x_1n            426.486    0.002
#    x_2n              0.008    0.000
#    x_3n              0.251    0.004
#    pbet_2            0.000
#    pbet_3            0.000
#
#Constraints:                               Slack (>=0)
#    L01 - (1)                                    0.000
#    L02 - (1)                                    0.000
#    L03 - (1)                                    0.000
#    L04 - (1)                                    0.000
#    L05 - (1)                                    0.000
#    L06 - (1)                                    0.000
#    L07 - (1)                                    0.000
#    L11 - (exp(-1*exp(-beta_2*(0.0-beta_3))))    0.000
#    L12 - (exp(-1*exp(-beta_2*(0.5-beta_3))))    0.000
#    L13 - (exp(-1*exp(-beta_2*(1.0-beta_3))))    0.000
#    L14 - (exp(-1*exp(-beta_2*(1.5-beta_3))))    0.000
#    L15 - (exp(-1*exp(-beta_2*(3.5-beta_3))))    0.000
#    L16 - (exp(-1*exp(-beta_2*(5.5-beta_3))))    0.000
#    L17 - (exp(-1*exp(-beta_2*(8.5-beta_3))))    0.000
#    L21-((_1*0.0*(_2*_3)-_1*_3*(_2*_3))*((-(-    0.000
#    L22-((_1*0.5*(_2*_3)-_1*_3*(_2*_3))*((-(-    0.000
#    L23-((_1*1.0*(_2*_3)-_1*_3*(_2*_3))*((-(-    0.000
#    L24-((_1*1.5*(_2*_3)-_1*_3*(_2*_3))*((-(-    0.000
#    L25-((_1*3.5*(_2*_3)-_1*_3*(_2*_3))*((-(-    0.000
#    L26-((_1*5.5*(_2*_3)-_1*_3*(_2*_3))*((-(-    0.000
#    L27-((_1*8.5*(_2*_3)-_1*_3*(_2*_3))*((-(-    0.000
#    L31-(-_1*_2*(-(-_2*0.0)*((_2*0.0-_2*_3)*(    0.000
#    L32-(-_1*_2*(-(-_2*0.5)*((_2*0.5-_2*_3)*(    0.000
#    L33-(-_1*_2*(-(-_2*1.0)*((_2*1.0-_2*_3)*(    0.000
#    L34-(-_1*_2*(-(-_2*1.5)*((_2*1.5-_2*_3)*(    0.000
#    L35-(-_1*_2*(-(-_2*3.5)*((_2*3.5-_2*_3)*(    0.000
#    L36-(-_1*_2*(-(-_2*5.5)*((_2*5.5-_2*_3)*(    0.000
#    L37-(-_1*_2*(-(-_2*8.5)*((_2*8.5-_2*_3)*(    0.000


install.packages('lavaan')
